DIM pit(15) AS LONG
DECLARE FUNCTION PITcal& ()
DECLARE SUB PITDelay (seconds!)
DECLARE SUB DOSDelay (seconds!)
DECLARE SUB VRTDelay (seconds!)
DECLARE SUB clearBuf ()
DECLARE SUB cyclePal (startColor%, endColor%, speed%)
'---------------------------------
DEFINT A-Z
TYPE paletteType
red AS INTEGER
green AS INTEGER
blue AS INTEGER
END TYPE
DECLARE SUB palette.Set (nColor%, pInfo AS paletteType)
DECLARE SUB palette.Get (nColor%, pInfo AS paletteType)
DECLARE SUB Palette.Fadeout ()
DECLARE SUB Palette.FadeIn ()
DIM SHARED pal AS paletteType
DIM SHARED pData(0 TO 255, 1 TO 3)
'---------------------------------
pit(0) = PITcal
spd = VAL(COMMAND$)
IF spd = 0 THEN INPUT spd
IF spd < 1 THEN spd = 1
IF spd > 20 THEN spd = 20
SCREEN 13
FOR n = 1 TO 64
p = n - 1
p2 = 63 - p
pal.red = p
pal.blue = p2
pal.green = p
palette.Set n, pal
NEXT
FOR n = 65 TO 127
p = n - 65
p2 = 63 - p
pal.red = 63
pal.blue = 0
pal.green = p2
palette.Set n, pal
NEXT
FOR n = 128 TO 190
p = n - 128
p2 = 63 - p
pal.red = p2
pal.blue = 0
pal.green = p
palette.Set n, pal
NEXT
FOR n = 191 TO 253
p = n - 191
p2 = 63 - p
pal.red = 0
pal.blue = p
pal.green = p2
palette.Set n, pal
NEXT
FOR c = 1 TO 254
LINE (c, 0)-(c, 200), c
NEXT
pal.red = 63
pal.blue = 63
pal.green = 63
palette.Set 255, pal
COLOR 255
LOCATE 1, 1: PRINT "Speed is"; spd
PRINT "To set the speed, type "
COLOR 63
PRINT "CIRC <speed> "
COLOR 255
PRINT "Where <speed> is 1 to 20"
oldtime! = TIMER: DO: LOOP WHILE oldtime! + 3 > TIMER: oldtime! = 0
CLS
n! = 200 / 255

FOR r! = 200 TO 0 STEP -n!
c = c + 1
IF c < 1 THEN c = 253
IF c > 253 THEN c = 1
CIRCLE (160, 100), r!, c
PAINT (160, 100), c + 1, c
NEXT r!

clearBuf
cyclePal 1, 253, spd

SUB clearBuf
FOR i = 0 TO 33
temp$ = INKEY$
NEXT
END SUB

SUB cyclePal (startColor, endColor, speed)
DIM pdat(0 TO 255) AS paletteType
SHARED pit() AS LONG
st = startColor
en = endColor
IF st >= en THEN EXIT SUB
FOR p = 0 TO 255
palette.Get p, pdat(p)
NEXT
DO

IF speed > 5 THEN
FOR zz = 1 TO speed - 5
pdat(st) = pdat(en)
FOR p = en TO st + 1 STEP -1
pdat(p) = pdat(p - 1)
NEXT
NEXT zz
ELSEIF speed = 5 THEN
pdat(st) = pdat(en)
FOR p = en TO st + 1 STEP -1
pdat(p) = pdat(p - 1)
PITDelay 1 / pit(0)
NEXT
ELSE
pdat(st) = pdat(en)
FOR p = en TO st + 1 STEP -1
pdat(p) = pdat(p - 1)
FOR n = 1 TO (6 - speed): PITDelay 1 / pit(0): NEXT
NEXT
END IF

FOR p = 0 TO 255
palette.Set p, pdat(p)
NEXT

LOOP WHILE INKEY$ = ""
END SUB

DEFSNG A-Z
SUB DOSDelay (seconds!)
   DEF SEG = 0
   d& = FIX(seconds! * 18.20444444#)
   FOR t& = t& TO d&
     d% = PEEK(&H46C) AND 255
     WHILE d% = (PEEK(&H46C) AND 255): WEND
   NEXT
END SUB

DEFINT A-Z
SUB Palette.FadeIn
DIM tT(1 TO 3)
FOR i = 1 TO 64
WAIT &H3DA, 8
  FOR O = 0 TO 255
    palette.Get O, pal
    tT(1) = pal.red
    tT(2) = pal.green
    tT(3) = pal.blue
    IF tT(1) < pData(O, 1) THEN tT(1) = tT(1) + 1
    IF tT(2) < pData(O, 2) THEN tT(2) = tT(2) + 1
    IF tT(3) < pData(O, 3) THEN tT(3) = tT(3) + 1
    pal.red = tT(1)
    pal.green = tT(2)
    pal.blue = tT(3)
    palette.Set O, pal
  NEXT O
NEXT i

END SUB

SUB Palette.Fadeout
DIM tT(1 TO 3)
FOR i = 0 TO 255
  palette.Get i, pal
  pData(i, 1) = pal.red
  pData(i, 2) = pal.green
  pData(i, 3) = pal.blue
NEXT i
FOR i = 1 TO 64
WAIT &H3DA, 8
  FOR O = 0 TO 255
    palette.Get O, pal
    tT(1) = pal.red
    tT(2) = pal.green
    tT(3) = pal.blue
    IF tT(1) > 0 THEN tT(1) = tT(1) - 1
    IF tT(2) > 0 THEN tT(2) = tT(2) - 1
    IF tT(3) > 0 THEN tT(3) = tT(3) - 1
    pal.red = tT(1)
    pal.green = tT(2)
    pal.blue = tT(3)
    palette.Set O, pal
  NEXT O
NEXT i
END SUB

SUB palette.Get (nColor%, pInfo AS paletteType)
OUT &H3C6, &HFF
OUT &H3C7, nColor%
pInfo.red = INP(&H3C9)
pInfo.green = INP(&H3C9)
pInfo.blue = INP(&H3C9)
END SUB

SUB palette.Set (nColor%, pInfo AS paletteType)
OUT &H3C6, &HFF
OUT &H3C8, nColor%
OUT &H3C9, pInfo.red
OUT &H3C9, pInfo.green
OUT &H3C9, pInfo.blue
END SUB

DEFSNG A-Z
FUNCTION PITcal&
   p& = 0: DEF SEG = 0: x% = (PEEK(&H46C) + 1) AND 255
   WHILE x% <> (PEEK(&H46C) AND 255): WEND
   WHILE x% = (PEEK(&H46C) AND 255)
      p& = p& + 33
      FOR t% = 1 TO 19: WAIT (64), 128, 128: WAIT (64), 128: NEXT
   WEND
   PITcal& = p& * 11.02
END FUNCTION

SUB PITDelay (seconds!)
   SHARED pit() AS LONG
   d& = FIX(seconds! * pit(0))
   FOR t& = 0 TO d&: WAIT 64, 128: WAIT 64, 128, 128: NEXT
END SUB

SUB VRTDelay (seconds!)
   d& = FIX(seconds! * 70)
   FOR t& = 0 TO d&: WAIT (&H3DA), 8: WAIT (&H3DA), 8, 8: NEXT
END SUB

